/*
 * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * The Universal Permissive License (UPL), Version 1.0
 *
 * Subject to the condition set forth below, permission is hereby granted to any
 * person obtaining a copy of this software, associated documentation and/or
 * data (collectively the "Software"), free of charge and under any and all
 * copyright rights in the Software, and any and all patent rights owned or
 * freely licensable by each licensor hereunder covering either (i) the
 * unmodified Software as contributed to or provided by such licensor, or (ii)
 * the Larger Works (as defined below), to deal in both
 *
 * (a) the Software, and
 *
 * (b) any piece of software and/or hardware listed in the lrgrwrks.txt file if
 * one is included with the Software each a "Larger Work" to which the Software
 * is contributed by such licensors),
 *
 * without restriction, including without limitation the rights to copy, create
 * derivative works of, display, perform, and distribute the Software and make,
 * use, sell, offer for sale, import, export, have made, and have sold the
 * Software and the Larger Work(s), and to sublicense the foregoing rights on
 * either these or other terms.
 *
 * This license is subject to the following condition:
 *
 * The above copyright notice and either this complete permission notice or at a
 * minimum a reference to the UPL must be included in all copies or substantial
 * portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
package com.oracle.graal.python.nodes;

public abstract class ErrorMessages {
    public static final String ABSOLUTE_VALUE_TOO_LARGE = "absolute value too large";
    public static final String ARG_AFTER_MUST_BE_ITERABLE = "argument after * must be an iterable, not %p";
    public static final String ARG_CONVERTED_NOT_EXECUTABLE = "argument converted is not executable";
    public static final String ARG_D_MUST_BE_S = "%s arg %d must be a %s";
    public static final String ARG_D_MUST_BE_S_NOT_P = "%s argument %d must be %s, not %p";
    public static final String ARG_S_MUST_BE_S_NOT_P = "%s argument %s must be %s, not %p";
    public static final String ARG_D_MUST_BE_S_OR_S = "%s argument %d must be '%s' or '%s'";
    public static final String ARG_D_MUST_NOT_BE_EMPTY = "arg %d must not be empty";
    public static final String ARG_EXPECTED_GOT = "%s argument expected, got %p";
    public static final String ARG_IS_EMPTY_SEQ = "%s() arg is an empty sequence";
    public static final String ARG_MUST_BE_INT_OR_HAVE_FILENO_METHOD = "argument must be an int, or have a fileno() method.";
    public static final String ARG_MUST_BE_NUMBER = "%s argument must be a number, not '%p'";
    public static final String ARG_MUST_BE_S_NOT_P = "%s argument must be a %s, not %p";
    public static final String ARG_MUST_BE_STRING_OR_BYTELIKE_OR_NUMBER = "%s argument must be a string, a bytes-like object or a number, not %p";
    public static final String ARG_MUST_BE_STRING_OR_NUMBER = "%s argument must be a string or a number, not '%p'";
    public static final String ARG_MUST_BE_UNICODE = "%s argument %d must be a unicode character, not %p";
    public static final String ARG_MUST_NOT_BE_ZERO = "%s arg %d must not be zero";
    public static final String ARG_NOT_IN_RANGE = "%s arg not in range(%s)";
    public static final String ARG_SHOULD_NOT_EXCEED = "%s argument should not exceed %d";
    public static final String ARGS_MUST_HAVE_SAME_LENGTH = "%s arguments must have same length";
    public static final String ARRAY_ASSIGN_OUT_OF_BOUNDS = "array assignment index out of range";
    public static final String ARRAY_OUT_OF_BOUNDS = "array index out of range";
    public static final String ARRAY_SIZE_TOO_LARGE = "array size too large";
    public static final String ATTEMP_TO_RELEASE_RECURSIVE_LOCK = "attempt to release recursive lock not owned by thread";
    public static final String ATTEMPT_TO_ASSIGN_SEQ_OF_SIZE_TO_SLICE_OF_SIZE = "attempt to assign sequence of size %d to extended slice of size %d";
    public static final String ATTR_NAME_MUST_BE_STRING = "attribute name must be string, not '%p'";
    public static final String ATTR_S_OF_S_IS_NOT_READABLE = "attribute %s of %s objects is not readable";
    public static final String ATTR_S_OF_S_IS_NOT_WRITABLE = "attribute %s of %s is not writable";
    public static final String ATTR_S_OF_S_OBJ_IS_NOT_WRITABLE = "attribute %s of %s object is not writable";
    public static final String ATTR_S_READONLY = "attribute %s is read-only";
    public static final String ATTR_VALUE_MUST_BE_BOOL = "attribute value type must be bool";
    public static final String B_REQUIRES_BYTES_OR_OBJ_THAT_IMPLEMENTS_S_NOT_P = "%%b requires a bytes-like object, or an object that implements __bytes__, not '%p'";
    public static final String BAD_ARG_TO_INTERNAL_FUNC = "bad argument to internal function";
    public static final String BAD_ARG_TO_INTERNAL_FUNC_P = "bad argument to internal function %p";
    public static final String BAD_ARG_TO_INTERNAL_FUNC_WAS_S_P = "bad argument to internal function, was '%s' (type '%p')";
    public static final String BAD_ARG_TYPE_FOR_BUILTIN_OP = "bad argument type for built-in operation";
    public static final String BAD_COMPRESSION_LEVEL = "Bad compression level";
    public static final String BAD_FILE_DESCRIPTOR = "bad file descriptor";
    public static final String BAD_MARSHAL_DATA = "bad marshal data";
    public static final String BAD_OPERAND_FOR = "bad operand type for %s%s: '%p'";
    public static final String BAD_TYPECODE = "bad typecode (must be i, d, b, B, or l)";
    public static final String BASE_OUT_OF_RANGE_FOR_INT = "base is out of range for int()";
    public static final String BOOL_SHOULD_RETURN_BOOL = "__bool__ should return bool, returned %p";
    public static final String BUFFER_INDICES_MUST_BE_INTS = "buffer indices must be integers, not %p";
    public static final String BYTE_STR_IS_TOO_LARGE = "byte string is too large";
    public static final String BYTEARRAY_OUT_OF_BOUNDS = "bytearray index out of range";
    public static final String BYTEORDER_MUST_BE_LITTLE_OR_BIG = "byteorder must be either 'little' or 'big'";
    public static final String BYTESLIKE_OBJ_REQUIRED = "a bytes-like object is required, not '%p'";
    public static final String C_ARG_NOT_IN_RANGE = "%%c arg not in range(0x%s)";
    public static final String CALL_STACK_NOT_DEEP_ENOUGH = "call stack is not deep enough";
    public static final String CALLING_ARG_CONVERTER_FAIL_EXPECTED_D_GOT_P = "calling argument converter failed; expected %d but got %d parameters.";
    public static final String CALLING_ARG_CONVERTER_FAIL_INCOMPATIBLE_PARAMS = "calling argument converter failed; incompatible parameters '%s'";
    public static final String CALLING_ARG_CONVERTER_FAIL_UNEXPECTED_RETURN = "calling argument converter failed; unexpected return value %s";
    public static final String CALLING_NATIVE_FUNC_EXPECTED_ARGS = "Calling native function %s expected %d arguments but got %d.";
    public static final String CALLING_NATIVE_FUNC_FAILED = "Calling native function %s failed: %m";
    public static final String CAN_ONLY_ASSIGN_S_TO_S_S_NOT_P = "can only assign %s to %s.%s, not %p";
    public static final String CAN_ONLY_CONCAT_S_NOT_P_TO_S = "can only concatenate %s (not \"%p\") to %s";
    public static final String CAN_ONLY_JOIN_ITERABLE = "can only join an iterable";
    public static final String CANNOT_ASSIGN_TO = "cannot assign to %s";
    public static final String CANNOT_BE_INTEPRETED_AS_INT = "%s cannot be interpreted as int (type %p)";
    public static final String CANNOT_BE_INTEPRETED_AS_LONG = "%s cannot be interpreted as long (type %p)";
    public static final String CANNOT_BE_NEGATIVE = "%s cannot be negative";
    public static final String CANNOT_CALL_CTOR_OF = "cannot call constructor of %s";
    public static final String CANNOT_CLOSE_EXPORTED_PTRS_EXIST = "cannot close exported pointers exist";
    public static final String CANNOT_CONERT_DICT_UPDATE_SEQ = "cannot convert dictionary update sequence element #%d to a sequence";
    public static final String CANNOT_CONVERT_DICT_UPDATE_SEQ = "cannot convert dictionary update sequence element #%d to a sequence";
    public static final String CANNOT_CONVERT_FLOAT_F_TO_INT = "cannot convert float %f to integer";
    public static final String CANNOT_CONVERT_OBJ_TO_C_STRING = "Cannot convert object of type %p to C string.";
    public static final String CANNOT_CONVERT_S_OBJ_TO_BYTES = "cannot convert '%p' object to bytes";
    public static final String CANNOT_CONVERT_S_TO_INT = "cannot convert %s to integer";
    public static final String CANNOT_CONVERT_S_TO_INT_RATIO = "cannot convert %s to integer ratio";
    public static final String CANNOT_CONVERT_TO = "cannot convert %s to %s";
    public static final String CANNOT_CREATE_BUFFER_FOR = "cannot create buffer for object %s";
    public static final String CANNOT_CREATE_CALL_TARGET = "cannot create a call target from the code object: %p";
    public static final String CANNOT_CREATE_INSTANCES = "cannot create '%s' instances";
    public static final String CANNOT_CREATE_WEAK_REFERENCE_TO = "cannot create weak reference to '%p' object";
    public static final String CANNOT_DELETE_ATTRIBUTE = "can't delete %s.%s";
    public static final String CANNOT_GET_SHAPE_OF_NATIVE_CLS = "cannot get shape of native class";
    public static final String CANNOT_GET_CONSISTEMT_METHOD_RESOLUTION = "Cannot create a consistent method resolution order (MRO) for bases %p, %p";
    public static final String CANNOT_HANDLE_ZIP_FILE = "cannot handle Zip file: '%s'";
    public static final String CANNOT_IMPORT_NAME = "cannot import name '%s'";
    public static final String CANNOT_INITIALIZE_WITH = "cannot initialize %s with %s%s";
    public static final String CANNOT_LOAD = "cannot load %s: %s";
    public static final String CANNOT_LOAD_M = "cannot load %s: %m";
    public static final String CANNOT_MMAP_FILE = "cannot mmap file";
    public static final String CANNOT_RELEASE_UNAQUIRED_LOCK = "cannot release un-acquired lock";
    public static final String CANNOT_RESIZE_BUFFER = "cannot resize buffer";
    public static final String CANNOT_SPECIFY_FILTERS = "Cannot specify filters except with FORMAT_RAW";
    public static final String CANNOT_SPECIFY_BOTH_COMMA_AND_UNDERSCORE = "Cannot specify both ',' and '_'.";
    public static final String CANNOT_SPECIFY_C_WITH_C = "Cannot specify '%c' with '%c'.";
    public static final String CANNOT_SPECIFY_MEM_LIMIT = "Cannot specify memory limit with FORMAT_RAW";
    public static final String CANNOT_SPECIFY_PREST_AND_FILTER_CHAIN = "Cannot specify both preset and filter chain";
    public static final String CANNOT_USE_TO_INITIALIZE_ARRAY = "cannot use a %p to initialize an array with typecode '%s'";
    public static final String CANT_CONCAT_S_TO_P = "can't concat %s to %p";
    public static final String CANT_CONVERT_TO_FLOAT = "can't convert %s to float";
    public static final String CANT_CONVERT_TO_STR_EXPLICITELY = "Can't convert '%p' object to str implicitly";
    public static final String CANT_DELETE = "can't delete '%s'";
    public static final String CANT_FIND_MODULE = "can't find module '%s'";
    public static final String CANT_MULTIPLY_SEQ_BY_NON_INT = "can't multiply sequence by non-int of type '%p'";
    public static final String CANT_PICKLE_FUNC_OBJS = "can't pickle function objects";
    public static final String CANT_SET_ATTRIBUTES_OF_TYPE = "can't set attributes of %s";
    public static final String CANT_SET_ATTRIBUTES_OF_TYPE_S = "can't set attributes of built-in/extension type '%s'";
    public static final String CANT_SPECIFY_TIMEOUT_FOR_NONBLOCKING = "can't specify a timeout for a non-blocking call";
    public static final String CANT_TAKE_FLOOR_OR_MOD_OF_COMPLEX = "can't take floor or mod of complex number.";
    public static final String CAPI_SYM_NOT_CALLABLE = "C API symbol %s is not callable";
    public static final String CATCHING_CLS_NOT_ALLOWED = "catching classes that do not inherit from BaseException is not allowed";
    public static final String CHARACTER_MAPPING_MUST_BE_IN_RANGE = "character mapping must be in range(0x%s)";
    public static final String CHARACTER_MAPPING_MUST_RETURN_INT_NONE_OR_STR = "character mapping must return integer, None or str";
    public static final String CHR_DOES_NOT_SUPPORT = "chr does not support PInt ";
    public static final String CLASS_ASIGMENT_S_LAYOUT_DIFFERS_FROM_S = "__class__ assignment: '%s' object layout differs from '%s'";
    public static final String CLASS_ASSIGMENT_ONLY_SUPPORTED_FOR_HEAP_TYPES_OR_MODTYPE_SUBCLASSES = "__class__ assignment only supported for heap types or ModuleType subclasses, not '%p'";
    public static final String CLASS_MUST_BE_SET_TO_CLASS = "__class__ must be set to a class, not '%p' object";
    public static final String MUST_BE_SET_TO_S_NOT_P = "%s must be set to a %s, not a '%p'";
    public static final String CLASSPATH_ARG_MUST_BE_STRING = "classpath argument %d must be string, not %p";
    public static final String CODE_OBJ_NO_FREE_VARIABLES = "code object passed to %s may not contain free variables";
    public static final String COMPILE_MUST_BE = "compile() mode must be 'exec', 'eval' or 'single'";
    public static final String COMPLEX_CANT_TAKE_ARG = "complex() can't take second arg if first is a string";
    public static final String COMPLEX_EXPONENTIATION = "complex exponentiation";
    public static final String COMPLEX_ZERO_TO_NEGATIVE_POWER = "0.0 to a negative or complex power";
    public static final String COMPLEX_MODULO = "complex modulo";
    public static final String COMPLEX_RETURNED_NON_COMPLEX = "__complex__ returned non-complex (type %p)";
    public static final String COMPLEX_SHOULD_RETURN_COMPLEX = "__complex__ should return a complex object";
    public static final String CONTIGUOUS_BUFFER = "contiguous buffer";
    public static final String CONVERTER_FUNC_FAILED_TO_SET_ERROR = "converter function failed to set an error on failure";
    public static final String CORRUPTED_CAPI_LIB_OBJ = "corrupted C API library object: %s";
    public static final String COULD_NOT_CONVERT_STRING_TO_FLOAT = "could not convert string to float: %s";
    public static final String COULD_NOT_GET_BYTES_OF_MEMORYVIEW = "could not get bytes of memoryview";
    public static final String COUNT_FUNC_MATH = "count function in Math";
    public static final String COVERAGE_TRACKER_NOT_RUNNING = "coverage tracker not running";
    public static final String CREATING_SOCKETS_NOT_ALLOWED = "creating sockets not allowed";
    public static final String DEFAULT_EXCEPT_MUST_BE_LAST = "default 'except:' must be last";
    public static final String DESC_S_FOR_S_DOESNT_APPLY_TO_S = "descriptor '%s' for '%s' objects doesn't apply to '%s' object";
    public static final String DESCRIPTOR_REQUIRES_OBJ = "descriptor '%s' requires a '%s' object but received a '%p'";
    public static final String DICT_CHANGED_DURING_COMPARISON = "dictionary changed during comparison operation";
    public static final String DICT_KEYS_CHANGED_DURING_ITERATION = "dictionary keys changed during iteration";
    public static final String CHANGED_SIZE_DURING_ITERATION = "%s changed size during iteration";
    public static final String DICT_MUST_BE_SET_TO_DICT = "__dict__ must have been set to a dictionary, not a '%p'";
    public static final String DICT_OF_P_OBJECTS_HAS_NO_ATTR = "'%p' dict of '%p' object has no attribute '__setitem__'";
    public static final String DICT_UPDATE_SEQ_ELEM_HAS_LENGTH_2_REQUIRED = "dictionary update sequence element #%d has length %d; 2 is required";
    public static final String DIVISION_BY_ZERO = "division by zero";
    public static final String S_DIVISION_BY_ZERO = "%s division by zero";
    public static final String SUPER_NO_CLASS = "super(): no arguments";
    public static final String EMPTY_SEPARATOR = "empty separator";
    public static final String EMPTY_STR_FOR_COMPLEX = "empty string for complex()";
    public static final String END_MUST_BE_NONE_OR_STRING = "end must be None or a string, not %p";
    public static final String ERROR57_SOCKET_CANNOT_BE_CONNECTED = "[Errno 57] Socket is not connected";
    public static final String ERROR_5_WHILE_DECOMPRESSING = "Error -5 while decompressing data: incomplete or truncated stream";
    public static final String ERROR_WRITING_FORKEXEC = "there was an error writing the fork_exec error to the error pipe";
    public static final String ESTAR_FORMAT_SPECIFIERS_NOT_ALLOWED = "'e*' format specifiers are not supported";
    public static final String EXCEPTION_CAUSE_MUST_BE_NONE_OR_DERIVE_FROM_BASE_EX = "exception cause must be None or derive from BaseException";
    public static final String EXCEPTION_CAUSES_MUST_DERIVE_FROM_BASE_EX = "exception causes must derive from BaseException";
    public static final String EXCEPTIONS_MUST_BE_CLASSES_OR_INSTANCES_DERIVING_FROM_BASE_EX = "exceptions must be classes or instances deriving from BaseException, not %p";
    public static final String EXCEPTIONS_MUST_DERIVE_FROM_BASE_EX = "exceptions must derive from BaseException";
    public static final String EXPECTED_ARG_TYPES_S_S_BUT_NOT_P_P = "expected argument types (%s) or (%s) but not (%p, %p)";
    public static final String EXPECTED_AT_MOST_D_ARGS_GOT_D = "%s expected at most %d arguments, got %d";
    public static final String EXPECTED_CHARACTER_BUT_STRING_FOUND = "%s expected a character, but string of length %d found";
    public static final String EXPECTED_FSPATH_TO_RETURN_STR_OR_BYTES = "expected %p.__fspath__() to return str or bytes, not %p";
    public static final String EXPECTED_OBJ_TYPE_S_GOT_P = "expected object of type %s, got %p";
    public static final String EXPECTED_S_GOT_P = "expected %s, got %p";
    public static final String EXPECTED_S_NOT_P = "expected %s, not %p";
    public static final String EXPECTED_S_P_FOUND = "expected %s, %p found";
    public static final String EXPECTED_STR_BYTE_OSPATHLIKE_OBJ = "expected str, bytes or os.PathLike object, not %p";
    public static final String EXPECTED_UNICODE_CHAR_NOT_P = "expected a unicode character, not %p";
    public static final String EXPONENT_TOO_LARGE = "exponent too large";
    public static final String FACTORIAL_NOT_DEFINED_FOR_NEGATIVE = "factorial() not defined for negative values";
    public static final String FILE_NOT_OPENED_FOR_READING = "file not opened for reading";
    public static final String FILL_CHAR_MUST_BE_LENGTH_1 = "The fill character must be exactly one character long";
    public static final String FILTER_SPEC_MUST_BE_DICT = "Filter specifier must be a dict or dict-like object";
    public static final String FILTER_SPECIFIER_MUST_HAVE = "Filter specifier must have an \"id\" entry";
    public static final String FIRST_ARG_MUST_BE_CALLABLE = "first argument must be callable";
    public static final String FIRST_TWO_MAKETRANS_ARGS_MUST_HAVE_EQ_LENGTH = "the first two maketrans arguments must have equal length";
    public static final String FLOAT_ARG_REQUIRED = "float argument required, not %p";
    public static final String FOREIGN_INVOCATION_DOESNT_SUPPORT_KEYWORD_ARG = "foreign invocation does not support keyword arguments";
    public static final String FOREIGN_OBJ_HAS_NO_ATTR_S = "foreign object has no attribute '%s'";
    public static final String FOREIGN_OBJ_ISNT_ITERABLE = "foreign object is not iterable";
    public static final String FORMAT_REQUIRES_MAPPING = "format requires a mapping";
    public static final String FORMAT_SPEC_MUST_BE_STRING = "format_spec must be a string";
    public static final String FORMATED_S_TOO_LONG = "formatted %s is too long (precision too large?)";
    public static final String FREE_VAR_REFERENCED_BEFORE_ASSIGMENT = "free variable '%s' referenced before assignment in enclosing scope";
    public static final String FUNC_CONSTRUCTION_NOT_SUPPORTED = "function construction not supported for (%p, %p, %p, %p, %p, %p)";
    public static final String FUNC_TAKES_AT_LEAST_D_ARGS = "function takes at least %d arguments (%d given)";
    public static final String FUNC_TAKES_EXACTLY_D_ARGS = "function takes exaclty %d arguments (%d given)";
    public static final String GENERATOR_EXPR_MUST_BE_PARENTHESIZED = "Generator expression must be parenthesized";
    public static final String GENERATOR_IGNORED_EXIT = "generator ignored GeneratorExit";
    public static final String GENERATOR_RAISED_STOPITER = "generator raised StopIteration";
    public static final String GENERATOR_ALREADY_EXECUTING = "generator already executing";
    public static final String GETTING_THER_SOURCE_NOT_SUPPORTED_FOR_P = "getting the source is not supported for '%p'";
    public static final String GLOBALS_MUST_BE_DICT = "%s() globals must be a dict, not %p";
    public static final String GOT_INVALID_CODESTRING = "got an invalid codestring trying to create a function code object";
    public static final String GOT_MULTIPLE_VALUES_FOR_ARG = "%s() got multiple values for argument '%s'";
    public static final String GOT_SOME_POS_ONLY_ARGS_PASSED_AS_KEYWORD = "%s() got some positional-only arguments passed as keyword arguments: '%s'";
    public static final String GOT_UNEXPECTED_KEYWORD_ARG = "%s() got an unexpected keyword argument '%s'";
    public static final String HAS_NO_ATTR = "%s has no attribute %s";
    public static final String HASH_SHOULD_RETURN_INTEGER = "__hash__ method should return an integer";
    public static final String HEX_VALUE_TOO_LARGE_AS_FLOAT = "hexadecimal value too large to represent as a float";
    public static final String HOST_ACCESS_NOT_ALLOWED = "host access is not allowed";
    public static final String HOST_LOOKUP_NOT_ALLOWED = "host lookup is not allowed";
    public static final String HOST_SYM_NOT_DEFINED = "host symbol %s is not defined or access has been denied";
    public static final String IDN_ENC_FAILED = "IDN encoding failed: %s";
    public static final String IF_YOU_GIVE_ONLY_ONE_ARG_TO_DICT = "if you give only one argument to maketrans it must be a dict";
    public static final String ILLEGAL_ARG = "illegal argument";
    public static final String ILLEGAL_EXPRESSION_FOR_AUGMENTED_ASSIGNEMNT = "illegal expression for augmented assignment";
    public static final String ILLEGAL_IP_STRING_PASSED_TO = "illegal IP address string passed to %s";
    public static final String ILLEGAL_SOCKET_ADDR_ARG = "%s: illegal sockaddr argument";
    public static final String IMPORT_START_ONLY_ALLOWED_AT_MODULE_LEVEL = "import * only allowed at module level";
    public static final String INCOMPLETE_FORMAT = "incomplete format";
    public static final String INDEX_NOT_INT = "%s: index not int";
    public static final String INDEX_OUT_OF_BOUNDS = "index out of bounds";
    public static final String INDEX_OUT_OF_RANGE = "index out of range";
    public static final String INDEX_RETURNED_NON_INT = "__index__ returned non-int (type %p)";
    public static final String INSTANCE_EX_MAY_NOT_HAVE_SEP_VALUE = "instance exception may not have a separate value";
    public static final String INSTANCE_HAS_NO_ATTR_S = "%s instance has no attribute '%s'";
    public static final String INT_CANT_CONVERT_STRING_WITH_EXPL_BASE = "int() can't convert non-string with explicit base";
    public static final String INT_TOO_LARGE_TO_CONVERT_TO_FLOAT = "int too large to convert to float";
    public static final String INTEGER_DIVISION_BY_ZERO = "ZeroDivisionError: integer division or modulo by zero";
    public static final String INTEGER_DIVISION_RESULT_TOO_LARGE = "integer division result too large for a float";
    public static final String INTEGER_EXPECTED_GOT_FLOAT = "integer argument expected, got float";
    public static final String INTEGER_GREATER_THAN_MAX = "integer is greater than maximum";
    public static final String INTEGER_IS_REQUIRED = "an integer is required";
    public static final String INTEGER_REQUIRED = "an integer is required";
    public static final String INTEGER_REQUIRED_GOT = "an integer is required (got type %p)";
    public static final String INTEGRITY_CHECKS_ONLY_SUPPORTED_BY = "Integrity checks are only supported by FORMAT_XZ";
    public static final String INTERMEDIATE_OVERFLOW_IN = "intermediate overflow in %s";
    public static final String INVALD_OR_UNREADABLE_CLASSPATH = "invalid or unreadable classpath: '%s' - %m";
    public static final String INVALID_ARGS = "%s: invalid arguments";
    public static final String INVALID_ARGS_FOR_ALLOCFUNC = "invalid arguments for allocfunc (expected 2 but got %s)";
    public static final String INVALID_ARGS_FOR_FASTCALL_METHOD = "invalid arguments for fastcall method (expected 3 but got %s)";
    public static final String INVALID_ARGS_FOR_FASTCALL_W_KEYWORDS_METHOD = "invalid arguments for fastcall_with_keywords method (expected 4 but got %s)";
    public static final String INVALID_ARGS_FOR_METHOD = "invalid arguments for method (expected 3 but got %s)";
    public static final String INVALID_BASE_TYPE_OBJ_FOR_CLASS = "Invalid base type object for class %s (base type was '%p' object).";
    public static final String INVALID_CAPI_FUNC = "invalid C API function: %s";
    public static final String INVALID_CONTAINER_FORMAT = "Invalid container format: %d";
    public static final String INVALID_ESCAPE_AT = "invalid %s escape at position %d";
    public static final String INVALID_ESCAPE_SEQ_AT = "invalid escape sequence '\\%s' at position %d";
    public static final String INVALID_FILE_DESCRIPTOR = "invalid file descriptor";
    public static final String INVALID_FILTER = "Invalid filter ID: %d";
    public static final String INVALID_FILTER_CHAIN_FOR_FORMAT = "Invalid filter chain for FORMAT_ALONE - must be a single LZMA1 filter";
    public static final String INVALID_INDEX_S = "invalid index %s";
    public static final String INVALID_INPUT_ELEM_TYPE = "Invalid input element type '%p'";
    public static final String INVALID_INSTANTIATION_OF_FOREIGN_OBJ = "invalid instantiation of foreign object";
    public static final String INVALID_ITEM_RETURNED_FROM_NATIVE_SEQ = "Invalid item type %s returned from native sequence storage (expected: %s)";
    public static final String INVALID_LITERAL_FOR_INT_WITH_BASE = "invalid literal for int() with base %s: %s";
    public static final String INVALID_LOCALE_CATEGORY = "invalid locale category";
    public static final String INVALID_MRO_OBJ = "invalid mro object";
    public static final String INVALID_NORMALIZATION_FORM = "invalid normalization form";
    public static final String INVALID_NUMBER_OF_ARGUMENTS = "%s: invalid number of arguments";
    public static final String INVALID_OBJ_FROM_NATIVE = "invalid object from native: %s";
    public static final String INVALID_PARAMS = "invalid parameters";
    public static final String INVALID_PTR_OBJ = "invalid pointer object: %s";
    public static final String INVALID_SYNTAX = "invalid syntax";
    public static final String INVALID_USE_OF_W_FORMAT_CHAR = "invalid use of 'w' format character";
    public static final String IS_EMPTY = "%s is empty";
    public static final String IS_NOT_IN_RANGE = "%s is not in range";
    public static final String D_IS_NOT_IN_RANGE = "%d is not in range";
    public static final String IS_NOT_ITERABLE = "%s is not iterable";
    public static final String IS_NOT_SUBTYPE_OF = "%s.__new__(%N): %N is not a subtype of %s";
    public static final String IS_NOT_TYPE_OBJ = "%s is not a type object (%p)";
    public static final String ISINSTANCE_ARG_2_MUST_BE_TYPE_OR_TUPLE_OF_CLSS_WAS = "issubclass() arg 2 must be a class or tuple of classes";
    public static final String ISINSTANCE_ARG_2_MUST_BE_TYPE_OR_TUPLE_OF_TYPE = "isinstance() arg 2 must be a type or tuple of types (was: %s)";
    public static final String ISNT_IN_BYTES_LITERAL = "%s is not in bytes literal";
    public static final String ISSUBCLASS_MUST_BE_CLASS_OR_TUPLE = "issubclass() arg 2 must be a class or tuple of classes";
    public static final String ITER_RETURNED_NON_ITERABLE = "iter() returned non-iterator of type '%p'";
    public static final String KEYWORD_NAMES_MUST_BE_STR_GOT_P = "keyword names must be str, get %p";
    public static final String KLASS_ARG_IS_NOT_HOST_OBJ = "klass argument '%p' is not a host object";
    public static final String LAZY_INITIALIZATION_FAILED = "lazy initialization of type %s failed";
    public static final String LEFT_BRACKET_WO_RIGHT_BRACKET_IN_ARG = "')' without '(' in argument parsing";
    public static final String LEN_SHOULD_RETURN_MT_ZERO = "__len__() should return >= 0";
    public static final String LIST_ASSIGMENT_INDEX_OUT_OF_RANGE = "list assignment index out of range";
    public static final String LIST_INDEX_OUT_OF_RANGE = "list index out of range";
    public static final String LIST_LENGTH_OUT_OF_RANGE = "list length out of range";
    public static final String LOCAL_VAR_REFERENCED_BEFORE_ASSIGMENT = "local variable '%s' referenced before assignment";
    public static final String LOCALS_MUST_BE_MAPPING = "%s() locals must be a mapping or None, not %p";
    public static final String LOST_SYSBREAKPOINTHOOK = "lost sys.breakpointhook";
    public static final String MALFORMED_STR_FOR_COMPLEX = "malformed string for complex() %s";
    public static final String MATH_DOMAIN_ERROR = "math domain error";
    public static final String MATH_RANGE_ERROR = "math range error";
    public static final String MAX_MARSHAL_STACK_DEPTH = "Maximum marshal stack depth";
    public static final String MEM_MAPPED_LENGTH_MUST_BE_POSITIVE = "memory mapped length must be positive";
    public static final String METACLASS_CONFLICT = "metaclass conflict: the metaclass of a derived class must be a (non-strict) subclass of the metaclasses of all its bases";
    public static final String METHOD_NAME_MUST_BE = "method name must be string, not %p";
    public static final String MISSING_D_REQUIRED_S_ARGUMENT_S_POS = "%s() missing required argument '%s' (pos %d)";
    public static final String MISSING_D_REQUIRED_S_ARGUMENT_S_S = "%s() missing %d required %s argument%s: '%s'";
    public static final String MMAP_INDEX_OUT_OF_RANGE = "mmap index out of range";
    public static final String MODULE_HAS_NO_ATTR_S = "module has no attribute '%s'";
    public static final String MODULE_PARTIALLY_INITIALIZED_S_HAS_NO_ATTR_S = "partially initialized module '%s' has no attribute '%s' (most likely due to a circular import)";
    public static final String MODULE_S_HAS_NO_ATTR_S = "module '%s' has no attribute '%s'";
    public static final String MUST_BE_A_CELL = "%s must be a cell";
    public static final String MUST_BE_BYTE_STRING_LEGTH1_NOT_P = "must be a byte string of length 1, not %p";
    public static final String MUST_BE_EITHER_OR = "%s: '%s' must be either %s or %s";
    public static final String MUST_BE_NON_NEGATIVE = "%s must be non-negative";
    public static final String MUST_BE_NON_NEGATIVE_INTEGER = "%s must be non-negative integer";
    public static final String MUST_BE_NUMERIC = "must be numeric, not %p";
    public static final String MUST_BE_REAL_NUMBER = "must be real number, not %p";
    public static final String MUST_BE_S_NOT_P = "%s must be a %s, not %p";
    public static final String MUST_BE_S_OR_S = "%s must be %s or %s";
    public static final String MUST_BE_SET_TO_STR_OBJ = "%s must be set to a string object";
    public static final String MUST_BE_STRINGS = "%s must be strings";
    public static final String MUST_BE_STRINGS_NOT_P = "%s must be strings, not %p";
    public static final String MUST_BE_TUPLE_OF_CLASSES_NOT_P = "%s.%s must be tuple of classes, not '%p'";
    public static final String MUST_SPECIFY_FILTERS = "Must specify filters for FORMAT_RAW";
    public static final String MUTATED_DURING_UPDATE = "%s mutated during update";
    public static final String NAME_IS_ASSIGNED_BEFORE_GLOBAL = "name '%s' is assigned to before global declaration";
    public static final String NAME_IS_ASSIGNED_BEFORE_NONLOCAL = "name '%s' is assigned to before nonlocal declaration";
    public static final String NAME_NOT_DEFINED = "name '%s' is not defined";
    public static final String NEED_BYTELIKE_OBJ = "decoding to str: need a bytes-like object, %p found";
    public static final String NEG_INF_PLUS_INF_IN = "-inf + inf in fsum";
    public static final String NEGATIVE_COUNT = "negative count";
    public static final String NEGATIVE_DATA_SIZE = "negative data size";
    public static final String NEGATIVE_SHIFT_COUNT = "negative shift count";
    public static final String NO_ACTIVE_EX_TO_RERAISE = "No active exception to reraise";
    public static final String NO_ARGS = "%s: no arguments";
    public static final String NO_BINDING_FOR_NON_LOCAL = "no binding for nonlocal variable \"%s\" found";
    public static final String NO_CACHED_CODE = "no cached code for %s";
    public static final String NO_CURRENT_FRAME = "%s: no current frame";
    public static final String NO_FUNCTION_FOUND = "no function %s%s found in %s";
    public static final String NO_SUCH_FILE_OR_DIR = "No such file or directory: '%s:/%s'";
    public static final String NO_SUCH_NAME = "no such name";
    public static final String NONLOCAL_AND_GLOBAL = "name '%s' is nonlocal and global";
    public static final String NONLOCAL_AT_MODULE_LEVEL = "nonlocal declaration not allowed at module level";
    public static final String NON_HEX_DIGIT_FOUND = "Non-hexadecimal digit found";
    public static final String NON_STRING_IN_CODE_SLOT = "non-string found in code slot";
    public static final String NOT_A_ZIP_FILE = "not a Zip file: '%s'";
    public static final String NOT_ALL_ARGS_CONVERTED_DURING_FORMATTING = "not all arguments converted during %s formatting";
    public static final String NOT_ALLOWED_S_S_FORMAT_SPECIFIERS_S = "%s not allowed %s%s format specifier%s";
    public static final String NOT_ENOUGH_ARGS_FOR_FORMAT_STRING = "not enough arguments for format string";
    public static final String NOT_ENOUGH_VALUES_TO_UNPACK = "not enough values to unpack (expected %d, got %d)";
    public static final String NOT_SUPPORTED_BETWEEN_INSTANCES = "'%s' not supported between instances of '%p' and '%p'";
    public static final String NUMBER_S_CANNOT_FIT_INTO_INDEXSIZED_INT = "number %s cannot fit into index-sized integer";
    public static final String OBJ_INDEX_MUST_BE_INT_OR_SLICES = "%s indices must be integers or slices, not %p";
    public static final String OBJ_CANNOT_BE_INTERPRETED_AS_INT = "%s cannot be interpreted as int (type %p)";
    public static final String OBJ_CANNOT_BE_INTERPRETED_AS_INTEGER = "'%p' object cannot be interpreted as an int";
    public static final String OBJ_DOES_NOT_SUPPORT_INDEXING = "'%s' object does not support indexing";
    public static final String OBJ_DOES_NOT_SUPPORT_ITEM_ASSIGMENT = "'%s' object does not support item assignment";
    public static final String P_OBJ_DOES_NOT_SUPPORT_ITEM_ASSIGMENT = "'%p' object does not support item assignment";
    public static final String OBJ_DOESNT_SUPPORT_DELETION = "'%p' object doesn't support item deletion";
    public static final String OBJ_HAS_NO_LEN = "object of type '%p' has no len()";
    public static final String OBJ_ISNT_CALLABLE = "'%p' object is not callable";
    public static final String OBJ_ISNT_ITERATOR = "'%p' object is not an iterator";
    public static final String OBJ_ISNT_REVERSIBLE = "'%p' object is not reversible";
    public static final String OBJ_NOT_ITERABLE = "'%p' object is not iterable";
    public static final String OBJ_NOT_SUBSCRIPTABLE = "'%p' object is not subscriptable";
    public static final String OBJ_OR_KLASS_ARGS_IS_NOT_HOST_OBJ = "the object '%p' or klass '%p' arguments is not a host object";
    public static final String OBJ_P_HAS_NO_ATTR_S = "'%p' object has no attribute '%s'";
    public static final String OBJ_S_HAS_NO_ATTR_S = "'%s' object has no attribute '%s'";
    public static final String ODD_LENGTH_STRING = "Odd-length string";
    public static final String ONLY_ACCEPTS_INTEGRAL_VALUES = "%s only accepts integral values";
    public static final String ONLY_DEFLATED_ALLOWED_AS_METHOD = "only DEFLATED (%d) allowed as method, got %d";
    public static final String PACKED_IP_WRONG_LENGTH = "packed IP wrong length for %s";
    public static final String PACKET_IP_WRONG_LENGTH_FOR = "packed IP wrong length for %s";
    public static final String PATCHED_DATETIME_CLASS = "patched datetime class: %r";
    public static final String POLYGLOT_ACCESS_NOT_ALLOWED = "polyglot access is not allowed";
    public static final String POLYGLOT_EVAL_MUST_PASS_STRINGS = "polyglot.eval must pass strings as either 'path' or a 'string' keyword";
    public static final String POLYGLOT_EVAL_WITH_STRING_MUST_PASS_LANG = "polyglot.eval with a string argument must pass a language or mime-type";
    public static final String POP_FROM_EMPTY_SET = "pop from an emtpy set";
    public static final String PORT_PROTO_NOT_FOUND = "port/proto not found";
    public static final String PRIVATE_IDENTIFIER_TOO_LARGE_TO_BE_MANGLED = "private identifier too large to be mangled";
    public static final String PROVIDED_OBJ_NOT_ARRAY = "provided object is not an array";
    public static final String PYTHON_INT_TOO_LARGE_TO_CONV_TO = "Python int too large to convert to %s";
    public static final String PYTHON_INT_TOO_LARGE_TO_CONV_TO_C_TYPE = "Python int too large to convert to %s-byte C type";
    public static final String RANGE_OUT_OF_BOUNDS = "range index out of range";
    public static final String RANGE_DOES_NOT_SUPPORT = "range does not support %s, %s, %s";
    public static final String RAW_FORMAT_NOT_SUPPORTED = "RAW format unsupported";
    public static final String READ_BYTE_OUT_OF_RANGE = "read byte out of range";
    public static final String READ_WRITE_BYTELIKE_OBJ = "read-write bytes-like object";
    public static final String READONLY_ATTRIBUTE = "readonly attribute";
    public static final String REQUIRES_CODE_OBJ = "%s() requires a code object with %d free vars, not %d";
    public static final String REQUIRES_INT_OR_CHAR = "%%%c requires int or char";
    public static final String S_FORMAT_NUMBER_IS_REQUIRED_NOT_S = "%%%s format: a number is required, not %p";
    public static final String S_FORMAT_INTEGER_IS_REQUIRED_NOT_S = "%%%s format: an integer is required, not %p";
    public static final String C_ARG_NOT_IN_RANGE256_DECIMAL = "%%c arg not in range(256)";
    public static final String C_REQUIRES_INT_IN_BYTE_RANGE_OR_SINGLE_BYTE = "%%c requires an integer in range(256) or a single byte";
    public static final String REQUIRES_OBJ_THAT_IMPLEMENTS_S = " %%r requires an object that implements %s";
    public static final String REQUIRES_STRING_AS_LEFT_OPERAND = "'in <string>' requires string as left operand, not %P";
    public static final String RESULT_TOO_MANY_ITEMS = "%s result has too many items";
    public static final String RETURN_OUTSIDE_FUNC = "'return' outside function";
    public static final String RETURNED_NON_FLOAT = "%p.%s returned non-float (type %p)";
    public static final String RETURNED_NON_INT = "%s returned a non-int (type %p)";
    public static final String P_S_RETURNED_NON_INT = "%p.%s returned a non int (type %p)";
    public static final String RETURNED_NON_INTEGER = "%s returned a non-integer";
    public static final String RETURNED_NON_INTEGRAL = "%s returned non-Integral (type %p)";
    public static final String RETURNED_NON_LONG = "%p.%s returned a non long (type %p)";
    public static final String RETURNED_NON_STRING = "%s returned non-string (type %p)";
    public static final String P_S_RETURNED_NON_STRING = "%p.%s returned non-string (type %p)";
    public static final String RETURNED_NONBYTES = "%s returned non-bytes (type %p)";
    public static final String RETURNED_NULL_WO_SETTING_ERROR = "%s returned NULL without setting an error";
    public static final String RETURNED_RESULT_WITH_ERROR_SET = "%s returned a result with an error set";
    public static final String RETURNED_UNEXPECTE_RET_CODE_EXPECTED_INT_BUT_WAS_S = "%s returned an unexpected return code; expected 'int' but was %s";
    public static final String S_S_CONFLICTS_WITH_CLASS_VARIABLE = "%s in %s conflicts with class variable";
    public static final String SECURITY_EX_WHILE_READING = "security exception while reading: '%s'";
    public static final String SEEK_OUT_OF_RANGE = "seek out of range";
    public static final String SEMAPHORE_NAME_TAKEN = "Semaphore name taken: '%s'";
    public static final String SEP_MUST_BE_NONE_OR_STRING = "sep must be None or a string, not %p";
    public static final String SET_DOES_NOT_SUPPORT_ITERABLE_OBJ = "set does not support iterable object %s";
    public static final String SHOULD_RETURN = "%s should return %s";
    public static final String SHOULD_RETURN_NONE = "%s should return None";
    public static final String SIGNAL_MUST_BE_SIGIGN_SIGDFL_OR_CALLABLE_OBJ = "signal handler must be signal.SIG_IGN, signal.SIG_DFL, or a callable object";
    public static final String SIGNED_CHAR_GREATER_THAN_MAX = "signed char is greater than maximum";
    public static final String SIGNED_INT_GREATER_THAN_MAX = "signed integer is greater than maximum";
    public static final String SIGNED_INT_LESS_THAN_MIN = "signed integer is less than minimum";
    public static final String SIGNED_SHORT_INT_GREATER_THAN_MAX = "signed short integer is greater than maximum";
    public static final String SIGNED_SHORT_INT_LESS_THAN_MIN = "signed short integer is less than minimum";
    public static final String SIZE_MUST_BE_D_OR_S = "size must be %d or %s";
    public static final String SLICE_INDICES_MUST_BE_INT_NONE_HAVE_INDEX = "slice indices must be integers or None or have an __index__ method";
    public static final String SLICE_STEP_CANNOT_BE_ZERO = "slice step cannot be zero";
    public static final String SLOT_DISALLOWED_WE_GOT_ONE = "%s slot disallowed: we already got one";
    public static final String STAR_WANTS_INT = "* wants int";
    public static final String STARRED_ASSIGMENT_MUST_BE_IN_LIST_OR_TUPLE = "starred assignment target must be in a list or tuple";
    public static final String STATE_VECTOR_INVALID = "state vector invalid.";
    public static final String STEP_1_NOT_SUPPORTED = "step != 1 not supported";
    public static final String STRING_ARG_WO_ENCODING = "string argument without an encoding";
    public static final String STRING_INDEX_OUT_OF_RANGE = "IndexError: string index out of range";
    public static final String SUBSTRING_NOT_FOUND = "substring not found";
    public static final String SUPER_OBJ_MUST_BE_INST_SUB_OR_TYPE = "super(type, obj): obj must be an instance or subtype of type";
    public static final String TAKES_D_OR_D_ARGS = "%s takes %d or %d arguments";
    public static final String TAKES_D_POS_ARG_S_BUT_D_POS_ARG_S = "%s() takes %d positional argument%s but %d positional argument%s (and %d keyword-only argument%s) were given%s";
    public static final String TAKES_D_POS_ARG_S_BUT_GIVEN_S = "%s() takes %d positional argument%s but %d %s given%s";
    public static final String TAKES_FROM_D_TO_D_POS_ARG_S_BUT_D_POS_ARG_S = "%s() takes from %d to %d positional argument%s but %d positional argument%s (and %d keyword-only argument%s) were given%s";
    public static final String TAKES_FROM_D_TO_D_POS_ARG_S_BUT_D_S_GIVEN_S = "%s() takes from %d to %d positional argument%s but %d %s given%s";
    public static final String TAKES_NO_KEYWORD_ARGS = "%s takes no keyword arguments";
    public static final String THROW_THIRD_ARG_MUST_BE_TRACEBACK = "throw() third argument must be a traceback object";
    public static final String TIMEOUT_VALUE_MUST_BE_POSITIVE = "timeout value must be positive";
    public static final String TIMEOUT_VALUE_TOO_LARGE = "timeout value is too large";
    public static final String TOLERANCE_MUST_NON_NEGATIVE = "tolerances must be non-negative";
    public static final String TOO_LARGE_TO_CONVERT_TO = "%s too large to convert to %s";
    public static final String TOO_MANY_ARG = "%s: too many arguments";
    public static final String TOO_MANY_VALUES_TO_UNPACK = "too many values to unpack (expected %d)";
    public static final String TRAILING_S_IN_STR = "Trailing %s in string";
    public static final String TRANS_TABLE_MUST_BE_256 = "translation table must be 256 characters long";
    public static final String TUPLE_ASSIGN_OUT_OF_BOUNDS = "tuple assignment index out of range";
    public static final String TUPLE_OUT_OF_BOUNDS = "tuple index out of range";
    public static final String TUPLE_OR_STRUCT_TIME_ARG_REQUIRED = "Tuple or struct_time argument required";
    public static final String TWO_STARRED_EXPRESSION_IN_ASSIGMENT = "two starred expressions in assignment";
    public static final String TYPE_DOES_NOT_PROVIDE_BASES = "type does not provide bases";
    public static final String TYPE_DOESNT_DEFINE_METHOD = "type %p doesn't define %s method";
    public static final String TYPE_IS_NOT_ACCEPTABLE_BASE_TYPE = "type '%p' is not an acceptable base type";
    public static final String TYPE_NAME_NO_NULL_CHARS = "type name must not contain null characters";
    public static final String TYPE_P_NOT_SUPPORTED_BY_FOREIGN_OBJ = "type '%p' is not supported by the foreign object";
    public static final String UNEXPECTED_KEYWORD_ARGS = "%s: unexpected keyword arguments";
    public static final String UNHASHABLE_TYPE = "unhashable type: '%p'";
    public static final String UNINITIALIZED_S_OBJECT = "uninitialized classmethod object";
    public static final String UNKNOWN_ADDR_FAMILY = "unknown address family %d";
    public static final String UNKNOWN_ATTR = "Unknown attribute: '%s'";
    public static final String UNKNOWN_ENCODING = "unknown encoding %s";
    public static final String UNKNOWN_ERROR_HANDLER = "unknown error handler name '%s'";
    public static final String UNKNOWN_FORMAT_CODE = "Unknown format code '%c' for object of type '%s'";
    public static final String UNKNOWN_S_TYPE = "unknown %s type";
    public static final String UNOPERABLE_TYPES_P_P = "unorderable types: %p < %p";
    public static final String UNRECOGNIZED_FORMAT_CHAR = "unrecognized format char in arguments parsing: %c";
    public static final String UNRECOGNIZED_KIND = "unrecognized kind";
    public static final String UNSIGNED_BYTE_INT_GREATER_THAN_MAX = "unsigned byte integer is greater than maximum";
    public static final String UNSIGNED_BYTE_INT_LESS_THAN_MIN = "unsigned byte integer is less than minimum";
    public static final String UNSUPPORTED_FORMAT_CHAR_AT_INDEX = "unsupported format character '%c' (0x%x) at index %d";
    public static final String UNSUPPORTED_INSTANCEOF = "unsupported instanceof(%p, %p)";
    public static final String UNSUPPORTED_LOCALE_SETTING = "unsupported locale setting";
    public static final String UNSUPPORTED_OBJ_IN = "unsupported object in '%s'";
    public static final String UNSUPPORTED_OPERAND_P = "unsupported operand '%p'";
    public static final String UNSUPPORTED_OPERAND_TYPES_FOR_S_P_AND_P = "unsupported operand type(s) for %s: '%p' and '%p'";
    public static final String UNSUPPORTED_OPERAND_TYPES_FOR_S_P_P_P = "unsupported operand type(s) for %s(): '%p', '%p', '%p'";
    public static final String UNSUPPORTED_OPERAND_TYPES_FOR_S_PR_S_P_AND_P = "unsupported operand type(s) for %s or %s(): '%p' and '%p'";
    public static final String UNSUPPORTED_SIZE_WAS = "unsupported %s size; was: %d";
    public static final String UNSUPPORTED_STR_TYPE = "unsupported string type: %s";
    public static final String UNSUPPORTED_TARGET_SIZE = "Unsupported target size: %d";
    public static final String VALUE_EXPECTED = "%s value expected";
    public static final String VALUE_TOO_LARGE_TO_FIT_INTO_INDEX = "value too large to fit into index-sized integer";
    public static final String WAS_NOT_POSSIBLE_TO_MARSHAL = "Was not possible to marshal";
    public static final String WAS_NOT_POSSIBLE_TO_MARSHAL_P = "Was not possible to marshal %p";
    public static final String WEAK_OBJ_GONE_AWAY = "weak object has gone away";
    public static final String WHILE_PREPARING_TO_DECOMPRESS_DATA = "while preparing to decompress data";
    public static final String WORK_DIR_NOT_ACCESSIBLE = "working directory %s is not accessible";
    public static final String WRITE_BYTE_OUT_OF_RANGE = "write byte out of range";
    public static final String X_NOT_IN_LIST = "x not in list";
    public static final String X_NOT_IN_TUPLE = "tuple.index(x): x not in tuple";
    public static final String YOU_MAY_SPECIFY_EITHER_OR_BUT_NOT_BOTH = "%s: you may specify either '%s' or '%s' but not both";
    public static final String ZIPIMPORT_CANNOT_REWAD_ARCH_MEMBERS = "zipimport: cannot read archive members large than 2GB";
    public static final String ZIPIMPORT_CANT_READ_DATA = "zipimport: can't read data";
    public static final String ZIPIMPORT_WRONG_CACHED_FILE_POS = "zipimport: wrong cached file position";
    public static final String ACCESS_TO_INTERNAL_LANG_NOT_PERMITTED = "access to internal language %s is not permitted";
    public static final String POW_BASE_NOT_INVERTIBLE = "base is not invertible for the given modulus";
    public static final String POW_ZERO_CANNOT_RAISE_TO_NEGATIVE_POWER = "0.0 cannot be raised to a negative power";
    public static final String S_ALIGNMENT_FLAG_NOT_ALLOWED_FOR_COMPLEX_FMT = "'%c' alignment flag is not allowed in complex format specifier";
    public static final String ZERO_PADDING_NOT_ALLOWED_FOR_COMPLEX_FMT = "Zero padding is not allowed in complex format specifier";
    public static final String POW_THIRD_ARG_CANNOT_BE_ZERO = "pow() 3rd argument cannot be 0";
    public static final String CANNOT_ENCODE_DOCSTR = "'utf-8' codec can't encode docstring '%s'";
    public static final String PRECISION_NOT_ALLOWED_FOR_INT = "Precision not allowed in integer format specifier";
    public static final String SIGN_NOT_ALLOWED_WITH_C_FOR_INT = "Sign not allowed with integer format specifier 'c'";
    public static final String CAPI_LOAD_ERROR = "Could not load C API from %s.";
    public static final String NATIVE_ACCESS_NOT_ALLOWED = "Cannot run any C extensions because native access is not allowed.";
    public static final String HPY_LOAD_ERROR = "Could not load HPy C API from %s.";
}
